summaryrefslogtreecommitdiffstats
path: root/system/mongodb/mongodb.SlackBuild
diff options
context:
space:
mode:
Diffstat (limited to 'system/mongodb/mongodb.SlackBuild')
-rw-r--r--system/mongodb/mongodb.SlackBuild53
1 files changed, 28 insertions, 25 deletions
diff --git a/system/mongodb/mongodb.SlackBuild b/system/mongodb/mongodb.SlackBuild
index e2d613fe69..7bcc41e901 100644
--- a/system/mongodb/mongodb.SlackBuild
+++ b/system/mongodb/mongodb.SlackBuild
@@ -3,6 +3,7 @@
# Slackware build script for MongoDB
# Copyright 2015 Miguel De Anda <miguel@thedeanda.com>
+# Copyright 2023-2024 Willy Sudiarto Raharjo <willysr@slackbuilds.org>
# All rights reserved.
#
# Redistribution and use of this script, with or without modification, is
@@ -26,11 +27,10 @@
cd $(dirname $0) ; CWD=$(pwd)
PRGNAM="mongodb"
-VERSION=${VERSION:-5.0.4}
+VERSION=${VERSION:-7.0.8}
BUILD=${BUILD:-1}
TAG=${TAG:-_SBo}
PKGTYPE=${PKGTYPE:-tgz}
-MAKEJOBS=${MAKEJOBS:-1}
if [ -z "$ARCH" ]; then
case "$( uname -m )" in
@@ -40,9 +40,6 @@ if [ -z "$ARCH" ]; then
esac
fi
-# If the variable PRINT_PACKAGE_NAME is set, then this script will report what
-# the name of the created package would be, and then exit. This information
-# could be useful to other scripts.
if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
echo "$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE"
exit 0
@@ -68,10 +65,8 @@ fi
set -e
-# Bail if user or group isn't valid on your system
-if ! getent passwd mongo 1>/dev/null 2>/dev/null; then
-
-cat << EOF
+bailout() {
+ cat << EOF
You must have a mongo user to run this script
@@ -79,18 +74,12 @@ cat << EOF
# useradd -u $MONGO_USER -d /var/lib/$PRGNAM -s /bin/false -g mongo mongo
EOF
+ exit 1
+}
- exit
-elif ! getent group mongo 1>/dev/null 2>/dev/null; then
-
-cat << EOF
-
- You must have a mongo group to run this script
- # groupadd -g $MONGO_GROUP mongo
-
-EOF
- exit
-fi
+# Bail if user or group isn't valid on your system
+getent passwd mongo &>/dev/null || bailout
+getent group mongo &>/dev/null || bailout
rm -fr $TMP/$SRC_FLDR $PKG
mkdir -p $TMP $PKG $OUTPUT
@@ -101,7 +90,7 @@ cd $SRC_FLDR
rm -fR src/third_party/{boost,pcre-*,snappy-*,yaml-cpp,zlib-*}
# remove compass
rm -fR src/mongo/installer/compass
-chown -R root.root .
+chown -R root:root .
find -L . \
\( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
-o -perm 511 \) -exec chmod 755 {} \; -o \
@@ -111,24 +100,37 @@ find -L . \
# thanks gentoo, also for these patches
for i in $CWD/patches/* ; do patch -p1 < $i ; done
+sed -i "s|GCC 11.3|GCC 11.2|g" SConstruct
+sed -i "s|__GNUC_MINOR__ < 3|__GNUC_MINOR__ < 2|g" SConstruct
+
scons_opts=(
--disable-warnings-as-errors
--use-system-boost
- --use-system-pcre
+ --use-system-pcre2
--use-system-snappy
--use-system-yaml
--use-system-zlib
--use-system-zstd
--use-sasl-client
+ --use-system-libbson
+ --use-system-mongo-c
--ssl
)
+# Thanks to Lockywolf
+# scons can use multiple jobs. For convenience, read MAKEFLAGS from the environment, if set
+JOBS="$( echo $MAKEFLAGS | sed 's,.*-j *\([0-9][0-9]*\)*.*,\1,' )"
+# or if no MAKEFLAGS, use the number of cores minus 1
+JOBS="${JOBS:-$(( $( nproc ) - 1 ))}"
+# or 1, if we really have one core
+[ "$JOBS" = "0" ] && JOBS=1
+
if [ "$ARCH" = "x86_64" ]; then
PREFIX=${PKG}/usr CFLAGS="$SLKCFLAGS" CXXFLAGS="$SLKCFLAGS" LDFLAGS="-L /lib$LIBDIRSUFFIX -L/usr/lib$LIBDIRSUFFIX" \
- ./buildscripts/scons.py "${scons_opts[@]}" --jobs="$MAKEJOBS" install-core
+ ./buildscripts/scons.py "${scons_opts[@]}" --force-jobs --jobs="$JOBS" install-core
else
PREFIX=${PKG}/usr CFLAGS="$SLKCFLAGS" CXXFLAGS="$SLKCFLAGS" LDFLAGS="-L /lib$LIBDIRSUFFIX -L/usr/lib$LIBDIRSUFFIX" \
- ./buildscripts/scons.py "${scons_opts[@]}" --jobs="$MAKEJOBS" --wiredtiger=off install-core
+ ./buildscripts/scons.py "${scons_opts[@]}" --force-jobs --jobs="$JOBS" --wiredtiger=off install-core
fi
# manual install
@@ -145,6 +147,7 @@ for i in $( find $PKG/usr/man -type l ) ; do ln -s $( readlink $i ).gz $i.gz ; r
mkdir -p ${PKG}/usr/doc/${PRGNAM}-${VERSION}
cp distsrc/* ${PKG}/usr/doc/${PRGNAM}-${VERSION}
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
mkdir -p $PKG/etc/{logrotate,rc}.d
cat $CWD/files/mongodb.conf > $PKG/etc/mongodb.conf.new
@@ -154,7 +157,7 @@ cat $CWD/files/rc.mongodb > $PKG/etc/rc.d/rc.mongodb.new
mkdir -p $PKG/var/{lib,log}/mongodb
chmod 750 $PKG/var/{lib,log}/mongodb
-chown mongo.mongo $PKG/var/{lib,log}/mongodb
+chown mongo:mongo $PKG/var/{lib,log}/mongodb
mkdir -p $PKG/install
cat $CWD/slack-desc > $PKG/install/slack-desc